const spawn = require('child_process').spawn;
const files = require('./files');

var svn = module.exports = {
	add : function(targetName) {
		return new Promise(function (resolve) {
			return run(['add', targetName]).then(() => {
				console.log(targetName, " a été ajouté");
				resolve();
			});
		});
	},

	revert : function(targetName) {
		return new Promise(function (resolve) {
			return run(['revert', '--recursive', targetName]).then(() => {
				// console.log(targetName, " a été revert");
				resolve();
			});
		});
	},

	delete : function(targetName) {
		return new Promise(function (resolve) {
			return run(['delete', '--force', targetName]).then(() => {
				console.log(targetName, " a été supprimé");
				resolve();
			});
		});
	},

	diff : function(targetName, oldDir, newDir) {
		return new Promise(function (resolve) {
			return run(['diff', '--old', oldDir, '--new', newDir]).then((result) => {
				resolve(result);
			});
		});
	},

	patch : function(targetName) {
		return new Promise(function (resolve) {
			return run(['patch', targetName + "/diff.patch"]).then(() => {
				console.log("Le patch a été effectué");
				resolve();
			});
		});
	},

	// merge : function(targetName, oldSvn, newSvn) {
	// 	return new Promise(function (resolve) {
	// 		return run(['merge', '--allow-mixed-revisions', '--accept=mine-conflict', oldSvn, newSvn, targetName]).then(() => {
	// 			console.log("Le merge a été effectué");
	// 			resolve();
	// 		});
	// 	});
	// },

	commit : function(targetName) {
		return new Promise(function (resolve) {
			return run(['commit', '-m projet ' + targetName, targetName]).then(() => {
				console.log(targetName, " a été commité");
				resolve();
			});
		});
	},

	ignore : function(targetName) {
		files.readFile(files.getFileInCurrentContext('svn.ignore'), function (err,data) {
			if (err) return console.log(err);
			return run(['propset', 'svn:global-ignores', data, targetName]).then(() => {
				console.log("La propriété global ignore a été ajouté sur le dossier", targetName);
			});
		});
	},

	copy : function(targetName, src, dest) {
		return new Promise(function (resolve) {
			return run(['copy', src, targetName+"/"+dest]).then(() => {
				console.log("Le SVN ", src, " a été copié");
				resolve();
			});
		});
	},

	update : function(targetName) {
		return new Promise(function (resolve) {
			return run(['update', targetName]).then(() => {
				console.log("Le SVN a été mis à jour");
				resolve();
			});
		});
	},

	cleanup : function(targetName) {
		return new Promise(function (resolve) {
			return run(['cleanup', targetName]).then(() => {
				console.log("Cleanup");
				resolve();
			});
		});
	},

	checkout : function(uri, targetName) {
		return new Promise(function (resolve) {
			return run(['checkout', uri, targetName]).then(() => {
				console.log("checkout");
				resolve();
			});
		});
	}
};

run = function(args) {
	return new Promise(function (resolve) {
		var cmd = 'svn';
		var text = '';
		var proc = spawn(cmd, args);
		proc.stdout.on('data', function(data) {
			text += data;
			console.log(text);
		});
		proc.stderr.on('data', function(data) {
			data = String(data);
			err = new Error(data);
			console.log('[SVN ERROR]', data);
		});
		proc.on('error', function(error) {
			var result = null;
			err = new Error('[SVN ERROR:404] svn command not found');
			if (error.code === 'ENOENT' && callback) {
				result = callback(err);
			}
			console.log(err);
		});
		proc.on('close', function(code) {
			var result = text;
			resolve(result);
		});
	});  
};